#include "FuzzyWorker.h"
#include "GlobalVariables.h"

int SelectionToolsX = 150;



void FuzzyWorker::initGUI()
{
	opt.iSpeciesNum = 100;
	opt.iChromosomeNum  = 4;
	opt.dMutationProbability = 0.2;

	std::stringstream directory_path;
	directory_path << working_directory.c_str()   << "arial.ttf";
	std::string directory_path_string = directory_path.str();

	Interface = new GCP_Controller(sdlRenderer,SCREEN_WIDTH,SCREEN_HEIGHT);
	Interface->setFont(directory_path.str());

	MainInterfaceForm = Interface->createForm(sdlRenderer);
	MainInterfaceForm->isTransparent = true;
	MainInterfaceForm->setFont(directory_path.str());
	MainInterfaceForm->setCaption(GCP_Math::RUSCP1251_TO_WCHAR(" "));
	MainInterfaceForm->setColor(c_white,c_black,c_aquadark,c_white);


	bStartWall = new GCP_Button();
	bStartWall->setCaption("");
	bStartWall->setWidthHeight(10,200);
	bStartWall->setPosition(0,50);
	bStartWall->setColor(c_black,c_black,c_black,c_black);

	bEndWall = new GCP_Button();
	bEndWall->setCaption("");
	bEndWall->setWidthHeight(10,200);
	bEndWall->setPosition(SCREEN_WIDTH-10,50);
	bEndWall->setColor(c_black,c_black,c_black,c_black);

	Car = new GCP_Button();
	Car->setCaption("[()()>>");
	Car->setWidthHeight(40,18);
	Car->setPosition(10,60);
	Car->setColor(c_white,c_black,c_aquadark,c_white);



	GCP_Button* bStart = new GCP_Button();
	bStart->setCaption(GCP_Math::RUSCP1251_TO_WCHAR(" "));
	bStart->setWidthHeight(150,25);
	bStart->setPosition(10,350);
	bStart->setColor(c_black,c_white,c_aquadark,c_white);
	bStart->setOnMouseLeftClick(this,&FuzzyWorker::FuzzyStartSimulation);

	GCP_Button* bStartLearn = new GCP_Button();
	bStartLearn->setCaption(GCP_Math::RUSCP1251_TO_WCHAR(" "));
	bStartLearn->setWidthHeight(150,25);
	bStartLearn->setPosition(10,380);
	bStartLearn->setColor(c_black,c_white,c_aquadark,c_white);
	bStartLearn->setOnMouseLeftClick(this,&FuzzyWorker::FuzzyStartEducation);

	GCP_Button* bStartLearn2 = new GCP_Button();
	bStartLearn2->setCaption(GCP_Math::RUSCP1251_TO_WCHAR(" "));
	bStartLearn2->setWidthHeight(150,25);
	bStartLearn2->setPosition(10,410);
	bStartLearn2->setColor(c_black,c_white,c_aquadark,c_white);
	bStartLearn2->setOnMouseLeftClick(this,&FuzzyWorker::FuzzyContinueEducation);

	bCheckbox = new GCP_CheckBox();
	bCheckbox->text = GCP_Math::RUSCP1251_TO_WCHAR(". ");
	bCheckbox->setWidthHeight(150,25);
	bCheckbox->setPosition(10,440);
	bCheckbox->isChecked = true;
	bCheckbox->cTextColor = c_black;
	//bCheckbox->setColor(c_black,c_white,c_aquadark,c_white);
	MainInterfaceForm->addComponent(bCheckbox);

	GCP_Button* bDefRules = new GCP_Button();
	bDefRules->setCaption(GCP_Math::RUSCP1251_TO_WCHAR(" "));
	bDefRules->setWidthHeight(150,25);
	bDefRules->setPosition(10,470);
	bDefRules->setColor(c_black,c_white,c_aquadark,c_white);
	bDefRules->setOnMouseLeftClick(this,&FuzzyWorker::defaultRules);


	GCP_Button* bOptions = new GCP_Button();
	bOptions->setCaption(GCP_Math::RUSCP1251_TO_WCHAR(""));
	bOptions->setWidthHeight(150,25);
	bOptions->setPosition(10,530);
	bOptions->setColor(c_black,c_white,c_aquadark,c_white);	
	MainInterfaceForm->addComponent(bOptions);


	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////OPTIONS FORM/////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	OptionsForm = new GCP_Form(sdlRenderer, 300, 400); 
	OptionsForm->setFont(directory_path.str());
	OptionsForm->isTransparent = false;	
	OptionsForm->isVisible = false;
	OptionsForm->setCaption(GCP_Math::RUSCP1251_TO_WCHAR(""));
	OptionsForm->setColor(c_white,c_black,c_aquadark,c_white);
	OptionsForm->setPosition(SCREEN_WIDTH/2 - OptionsForm->width/2,SCREEN_HEIGHT/2 - OptionsForm->height/2);
	OptionsForm->isDragable = true;
	OptionsForm->isParentLocking = true;
	bOptions->setOnMouseLeftClick(this,&FuzzyWorker::OnOptonsFormOpen);
	MainInterfaceForm->addSubForm(OptionsForm);

	int x0, y0, separation, i;
	x0 = 10;
	y0 = 50;
	separation = 30;


	i=0;
	GCP_Label *label11 = new GCP_Label();
	label11->setPosition(x0,y0);
	label11->cTextColor = c_black;
	label11->text = CP1251_TO_WCHAR("- :");
	label11->INFO = CP1251_TO_WCHAR(" ,   \n   \n");
	OptionsForm->addComponent(label11);

	Edit = new GCP_Edit();	
	Edit->setPosition(x0+140,y0+separation*i-5);
	OptionsForm->addComponent(Edit);
	Edit->setWidthHeight(130,separation-5);
	Edit->iBorderWidth = 2;
	Edit->cBackColor = c_black;
	Edit->cTextColor = c_black;
	Edit->setCaption(GCP_Math::doubleToString(opt.iSpeciesNum));
	Edit->inputType =  GCP_EDIT_DIGITONLY;
	Edit->cTextFieldBackColor = c_orange;
	
	i++;
	GCP_Label *label22 = new GCP_Label();
	label22->setPosition(x0,y0+separation*i);
	label22->cTextColor = c_black;
	label22->text = CP1251_TO_WCHAR("- :");
	label22->INFO = CP1251_TO_WCHAR("     , \n     \n  ");
	OptionsForm->addComponent(label22);

	Edit2 = new GCP_Edit();	
	Edit2->setPosition(x0+140,y0+separation*i-5);
	OptionsForm->addComponent(Edit2);
	Edit2->setWidthHeight(130,separation-5);
	Edit2->iBorderWidth = 2;
	Edit2->cBackColor = c_black;
	Edit2->cTextColor = c_black;
	Edit2->setCaption(GCP_Math::intToString(opt.iChromosomeNum));
	Edit2->inputType = GCP_EDIT_DIGITONLY;
	Edit2->cTextFieldBackColor = c_orange;

		
	i++;
	GCP_Label *label33 = new GCP_Label();
	label33->setPosition(x0,y0+separation*i);
	label33->cTextColor = c_black;
	label33->text = CP1251_TO_WCHAR("- :");
	label33->INFO = CP1251_TO_WCHAR("      \n   ");
	OptionsForm->addComponent(label33);

	Edit3 = new GCP_Edit();	
	Edit3->setPosition(x0+140,y0+separation*i-5);
	OptionsForm->addComponent(Edit3);
	Edit3->setWidthHeight(130,separation-5);
	Edit3->iBorderWidth = 2;
	Edit3->cBackColor = c_black;
	Edit3->inputType = GCP_EDIT_DOUBLEDIGIT;
	Edit3->cTextColor = c_black;	
	Edit3->setCaption(GCP_Math::doubleToString(opt.dMutationProbability));
	Edit3->cTextFieldBackColor = c_orange;

	GCP_Button *buttonOk = new GCP_Button();
	string bcaption5 = CP1251_TO_WCHAR("OK");
	buttonOk->setCaption(bcaption5);
	buttonOk->setPosition(OptionsForm->width/2-15,OptionsForm->height-50);
	buttonOk->setWidthHeight(30,25);
	buttonOk->setColor(c_black,c_white,c_aquadark,c_black);
	buttonOk->setOnMouseLeftClick(this, &FuzzyWorker::OnOptonsFormOkClick);
	OptionsForm->addComponent(buttonOk);

	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	

	GCP_Label* label = new GCP_Label();
	label->text = GCP_Math::RUSCP1251_TO_WCHAR(" ");
	label->setPosition(10,130);
	label->setColor(c_white,c_black,c_white,c_black);
	FZDistance_trinagleLow = new FuzzyTriangle(MainInterfaceForm,250,100,45,c_green);
	FZDistance_trinagleMedium = new FuzzyTriangle(MainInterfaceForm,400,100,45,c_orange);
	FZDistance_trinagleHigh = new FuzzyTriangle(MainInterfaceForm,550,100,45,c_red);
	FZDistance_trinagleLow->setRange(Car->xPos,bEndWall->xPos);
	FZDistance_trinagleMedium->setRange(Car->xPos,bEndWall->xPos);
	FZDistance_trinagleHigh->setRange(Car->xPos,bEndWall->xPos);
	GCP_Label* labela = new GCP_Label();
	labela->text = GCP_Math::RUSCP1251_TO_WCHAR("");
	labela->setPosition(bEndWall->xPos-100,130);
	labela->setColor(c_white,c_black,c_white,c_black);
	

	GCP_Label* label2 = new GCP_Label();
	label2->text = GCP_Math::RUSCP1251_TO_WCHAR(" ");
	label2->setPosition(10,180);
	label2->setColor(c_white,c_black,c_white,c_black);
	FZEnergy_trinagleLow = new FuzzyTriangle(MainInterfaceForm,250,150,45,c_green);
	FZEnergy_trinagleMedium = new FuzzyTriangle(MainInterfaceForm,400,150,45,c_orange);
	FZEnergy_trinagleHigh = new FuzzyTriangle(MainInterfaceForm,550,150,45,c_red);
	FZEnergy_trinagleLow->setRange(Car->xPos,bEndWall->xPos);
	FZEnergy_trinagleMedium->setRange(Car->xPos,bEndWall->xPos);
	FZEnergy_trinagleHigh->setRange(Car->xPos,bEndWall->xPos);
	GCP_Label* label2a = new GCP_Label();
	label2a->text = GCP_Math::RUSCP1251_TO_WCHAR(" ");
	label2a->setPosition(bEndWall->xPos-100,180);
	label2a->setColor(c_white,c_black,c_white,c_black);

	GCP_Label* label3 = new GCP_Label();
	label3->text = GCP_Math::RUSCP1251_TO_WCHAR(" ");
	label3->setPosition(10,230);
	label3->setColor(c_white,c_black,c_white,c_black);
	FZStop_trinagleLow = new FuzzyTriangle(MainInterfaceForm,250,200,45,c_green);
	FZStop_trinagleMedium = new FuzzyTriangle(MainInterfaceForm,400,200,45,c_orange);
	FZStop_trinagleHigh = new FuzzyTriangle(MainInterfaceForm,550,200,45,c_red);
	FZStop_trinagleLow->setOnlyOneLine();
	FZStop_trinagleMedium->setOnlyOneLine();
	FZStop_trinagleHigh->setOnlyOneLine();
	FZStop_trinagleLow->setRange(Car->xPos,bEndWall->xPos);
	FZStop_trinagleMedium->setRange(Car->xPos,bEndWall->xPos);
	FZStop_trinagleHigh->setRange(Car->xPos,bEndWall->xPos);
	GCP_Label* label3a = new GCP_Label();
	label3a->text = GCP_Math::RUSCP1251_TO_WCHAR(" ");
	label3a->setPosition(bEndWall->xPos-100,230);
	label3a->setColor(c_white,c_black,c_white,c_black);


	selectResult = new GCP_Select();
	selectResult->setPosition(SelectionToolsX+390,300);
	selectResult->setColor(c_white,c_black,c_white,c_black);
	selectResult->cBorderColor = c_black;
	selectResult->setWidthHeight(150,25);
	selectResult->iBorderWidth = 2;
	selectResult->options.draw_order = -1;
	selectResult->addItem(GCP_Math::RUSCP1251_TO_WCHAR(""));
	selectResult->addItem(GCP_Math::RUSCP1251_TO_WCHAR(" "));
	selectResult->addItem(GCP_Math::RUSCP1251_TO_WCHAR(" "));
	FZStop_trinagleLow->setCaption(GCP_Math::RUSCP1251_TO_WCHAR(" "));
	FZStop_trinagleMedium->setCaption(GCP_Math::RUSCP1251_TO_WCHAR(""));
	FZStop_trinagleHigh->setCaption(GCP_Math::RUSCP1251_TO_WCHAR(" "));


	GCP_Button* buttonAddRule = new GCP_Button();
	buttonAddRule->setCaption("+");
	buttonAddRule->setColor(c_black,c_white,c_aquadark,c_white);
	buttonAddRule->setWidthHeight(50,25);
	buttonAddRule->setPosition(730,300);
	buttonAddRule->setOnMouseLeftClick(this,&FuzzyWorker::OnAddRule);


	GCP_Label* selectIf1label = new GCP_Label();
	selectIf1label->text = GCP_Math::RUSCP1251_TO_WCHAR("                                                               ");
	selectIf1label->setPosition(SelectionToolsX,270);
	selectIf1label->setColor(c_white,c_black,c_white,c_black);
	selectIf1 = new GCP_Select();
	selectIf1->setPosition(SelectionToolsX+50,300);
	selectIf1->setColor(c_white,c_black,c_white,c_black);
	selectIf1->cBorderColor = c_black;
	selectIf1->setWidthHeight(150,25);
	selectIf1->iBorderWidth = 2;
	selectIf1->options.draw_order = -1;
	selectIf1->addItem(GCP_Math::RUSCP1251_TO_WCHAR(""));
	selectIf1->addItem(GCP_Math::RUSCP1251_TO_WCHAR(""));
	selectIf1->addItem(GCP_Math::RUSCP1251_TO_WCHAR(" "));	
	FZDistance_trinagleLow->setCaption(GCP_Math::RUSCP1251_TO_WCHAR(""));
	FZDistance_trinagleMedium->setCaption(GCP_Math::RUSCP1251_TO_WCHAR(""));
	FZDistance_trinagleHigh->setCaption(GCP_Math::RUSCP1251_TO_WCHAR(" "));
	
	selectIf2 = new GCP_Select();
	selectIf2->setPosition(SelectionToolsX+220,300);
	selectIf2->setColor(c_white,c_black,c_white,c_black);
	selectIf2->cBorderColor = c_black;
	selectIf2->setWidthHeight(150,25);
	selectIf2->iBorderWidth = 2;
	selectIf2->options.draw_order = -1;
	selectIf2->addItem(GCP_Math::RUSCP1251_TO_WCHAR(""));
	selectIf2->addItem(GCP_Math::RUSCP1251_TO_WCHAR(""));
	selectIf2->addItem(GCP_Math::RUSCP1251_TO_WCHAR(" "));	
	FZEnergy_trinagleLow->setCaption(GCP_Math::RUSCP1251_TO_WCHAR(""));
	FZEnergy_trinagleMedium->setCaption(GCP_Math::RUSCP1251_TO_WCHAR(""));
	FZEnergy_trinagleHigh->setCaption(GCP_Math::RUSCP1251_TO_WCHAR(" "));

	
	
	MainInterfaceForm->addComponent(buttonAddRule);
	MainInterfaceForm->addComponent(selectIf1label);
	MainInterfaceForm->addComponent(selectIf2);
	MainInterfaceForm->addComponent(selectIf1);
	MainInterfaceForm->addComponent(selectResult);
	MainInterfaceForm->addComponent(label);
	MainInterfaceForm->addComponent(label2);
	MainInterfaceForm->addComponent(label3);
	MainInterfaceForm->addComponent(labela);
	MainInterfaceForm->addComponent(label2a);
	MainInterfaceForm->addComponent(label3a);
    MainInterfaceForm->addComponent(bStart);
	MainInterfaceForm->addComponent(bStartLearn);	
	MainInterfaceForm->addComponent(bStartLearn2);
	MainInterfaceForm->addComponent(bStartWall);
	MainInterfaceForm->addComponent(bDefRules);	
	MainInterfaceForm->addComponent(bEndWall);
	MainInterfaceForm->addComponent(Car);

	//  
	CarInfo.numDistance = bEndWall->xPos  -   (Car->xPos+Car->width);


}



double distanceScale;
bool isStartedSimulation = false;


void FuzzyWorker::OnOptonsFormOpen(void* obj)
{
	Edit3->setCaption(GCP_Math::doubleToString(opt.dMutationProbability));
	Edit2->setCaption(GCP_Math::intToString(opt.iChromosomeNum));
	Edit->setCaption(GCP_Math::doubleToString(opt.iSpeciesNum));
	OptionsForm->toggleVisibility((void*)1);
}

void FuzzyWorker::OnOptonsFormOkClick(void* obj)
{
	opt.iSpeciesNum = GCP_Math::stringToInt((char*)(Edit->getCaption()).c_str());	
	opt.iChromosomeNum = GCP_Math::stringToInt((char*)(Edit2->getCaption()).c_str());
	opt.dMutationProbability = GCP_Math::stringToDouble((char*)(Edit3->getCaption()).c_str());
		
	OptionsForm->toggleVisibility((void*)1);
}
void* FuzzyWorker::SimulationFunc(void *obj)
{
	//obj = "010010101010"  - a char* of input parametrs represented in binary
	//return = "0" or "1"   - a char* of function success of fail

	char *input = (char*) obj;



	// . 
	string parametrs = input;
	int positioning = setPositionFromBinParametrs(parametrs);
	if(positioning == -1)
		return (void*)50000;

	FuzzyStartSimulation((void*)1);

	// 
	simulationResult result = drawSimulation();
	int count = 0;
	while ( result.status == "NOT DONE YET" && count<6000)
	{
		result = drawSimulation();
		count ++;
	}

	//    -> 0
	int resultVAL = 3000+result.value + CarInfo.dEnergy*1000;
    if(result.status == "SUCCESS")
	{
		resultVAL -= 1500;
		resultVAL -= (1500-result.value*9);
	}


	return (void*)resultVAL;
}

void FuzzyWorker::FuzzyContinueEducation(void *obj)
{	
	FuzzyStartEducation((void*)1);
}
void FuzzyWorker::FuzzyStartEducation(void *obj)
{	
	int mode = (int) obj;

	switch (mode)
	{
		case 1:	isContinueEducation = true; break;
		default: isContinueEducation = false;
	}

	//////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////GET BIN STRING WITH TRIANGLES COORDINATES
	////////////////////////////////////////////////////////////////////////////////////
	char bin[16];
	char *binParametrs;
	if(bCheckbox->isChecked)
		binParametrs = new char[432+16*9];	
	else binParametrs  = new char[432];	

	binParametrs[0] = '\0';
	GCP_Vector<FuzzyTriangle*> trianglesToBinCoord;
	trianglesToBinCoord.push_back(FZDistance_trinagleLow);
	trianglesToBinCoord.push_back(FZDistance_trinagleMedium);
	trianglesToBinCoord.push_back(FZDistance_trinagleHigh);

	trianglesToBinCoord.push_back(FZEnergy_trinagleLow);
	trianglesToBinCoord.push_back(FZEnergy_trinagleMedium);
	trianglesToBinCoord.push_back(FZEnergy_trinagleHigh);

	trianglesToBinCoord.push_back(FZStop_trinagleLow);
	trianglesToBinCoord.push_back(FZStop_trinagleMedium);
	trianglesToBinCoord.push_back(FZStop_trinagleHigh);

	int total=0;
	for(int j=0; j<trianglesToBinCoord.size(); j++)
	{
		GCP_Vector<int> *coord; 
		if(isContinueEducation)
			coord = trianglesToBinCoord.at(j)->getCoordinates();	
		else
		{
			coord = new GCP_Vector<int>();
			coord->push_back(GCP_Math::rnd()*790);
			coord->push_back(GCP_Math::rnd()*790);
			coord->push_back(GCP_Math::rnd()*790);
		}

		for(int i=0; i<coord->size(); i++){

			int  ss = coord->at(i);
			itoa(ss,bin,2);
			char tbin[17];
			int binsize  = strlen(bin)-1;
			for(int k=15; k>=0; k--)
			{
				if(binsize>-1){
				tbin[k] = bin[binsize];
				binsize--;}
				else tbin[k] = '0';
			}
			total += 16;
			tbin[16] = '\0';
			int len = strlen(binParametrs);
			strcat(binParametrs,tbin);
		}
	delete coord;
	}
	

	// 
	if(bCheckbox->isChecked)
	for(int i =0; i<9; i++)
	{
		int rndval = GCP_Math::rnd()*32000;
		itoa(rndval,bin,2);
		bin[15] = '\0';
		strcat(binParametrs,bin);
	}
	

	// .      - parameters
	//   - SimulationFunc

	string parameters = binParametrs;
	int a = parameters.size();
	string approxyParametrs;
	approxyParametrs = GCP_Math::GeneticApproximation(this,&FuzzyWorker::SimulationFunc,parameters,opt.iSpeciesNum,opt.iChromosomeNum, opt.dMutationProbability);
	setPositionFromBinParametrs(approxyParametrs);
	delete binParametrs;
	//////////////////////////////////////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////SET TRIANGLES COORDINATES WITH BIN STRING
	////////////////////////////////////////////////////////////////////////////////////
	


}

int FuzzyWorker::setPositionFromBinParametrs(string parametrs)
{	
	int maxsize;
	char *binParametrs;
	if(bCheckbox->isChecked)
		maxsize = 432+16*9;		
	else maxsize = 432;

	binParametrs = new char[maxsize];
	char bin[16];
	binParametrs[0] = '\0';

	int a;
	if(parametrs.size()!=maxsize)
		a = parametrs.size();  //SIZE MISMACH

	for(int i=0; i< maxsize; i++)
		binParametrs[i] = parametrs[i];

	GCP_Vector<int> newCoordinats;
	for(int i=0; i<maxsize; i+=16)
	{
		for(int j=0; j<16; j++)
			bin[j] = binParametrs[i+j];

		int decimal =  strtol(bin,0,2);	
		if(decimal < 0)
			return -1;
		decimal = decimal % 790;
		newCoordinats.push_back(decimal);
	}

	GCP_Vector<FuzzyTriangle*> trianglesFromDecCoord;
	trianglesFromDecCoord.push_back(FZDistance_trinagleLow);
	trianglesFromDecCoord.push_back(FZDistance_trinagleMedium);
	trianglesFromDecCoord.push_back(FZDistance_trinagleHigh);

	trianglesFromDecCoord.push_back(FZEnergy_trinagleLow);
	trianglesFromDecCoord.push_back(FZEnergy_trinagleMedium);
	trianglesFromDecCoord.push_back(FZEnergy_trinagleHigh);

	trianglesFromDecCoord.push_back(FZStop_trinagleLow);
	trianglesFromDecCoord.push_back(FZStop_trinagleMedium);
	trianglesFromDecCoord.push_back(FZStop_trinagleHigh);

	GCP_Vector<int> pos;
	for(int i =0; i<trianglesFromDecCoord.size(); i++)
	{		
		pos.clear();	
		pos.push_back(newCoordinats.pop_first());
		pos.push_back(newCoordinats.pop_first());
		pos.push_back(newCoordinats.pop_first());
		trianglesFromDecCoord.at(i)->setCoordinates(&pos);
	}



	// 
	if(bCheckbox->isChecked)
	{
		deleteRules();

		for(int i =0 ; i<9; i++)
		{
			int rules = newCoordinats.pop_first();
			rules = rules % 26;

			switch(rules)
			{
				case 0: selectIf1->selectItem(0);	selectIf2->selectItem(0);	selectResult->selectItem(0); OnAddRule((void*)1);	break;
				case 1: selectIf1->selectItem(0);	selectIf2->selectItem(0);	selectResult->selectItem(1); OnAddRule((void*)1);	break;
				case 2: selectIf1->selectItem(0);	selectIf2->selectItem(0);	selectResult->selectItem(2); OnAddRule((void*)1);	break;
				case 3: selectIf1->selectItem(0);	selectIf2->selectItem(1);	selectResult->selectItem(0); OnAddRule((void*)1);	break;
				case 4: selectIf1->selectItem(0);	selectIf2->selectItem(1);	selectResult->selectItem(1); OnAddRule((void*)1);	break;
				case 5: selectIf1->selectItem(0);	selectIf2->selectItem(1);	selectResult->selectItem(2); OnAddRule((void*)1);	break;
				case 6: selectIf1->selectItem(0);	selectIf2->selectItem(2);	selectResult->selectItem(0); OnAddRule((void*)1);	break;
				case 7: selectIf1->selectItem(0);	selectIf2->selectItem(2);	selectResult->selectItem(1); OnAddRule((void*)1);	break;
				case 8: selectIf1->selectItem(0);	selectIf2->selectItem(2);	selectResult->selectItem(2); OnAddRule((void*)1);	break;

				case 9: selectIf1->selectItem(1);	selectIf2->selectItem(0);	selectResult->selectItem(0); OnAddRule((void*)1);	break;
				case 10: selectIf1->selectItem(1);	selectIf2->selectItem(0);	selectResult->selectItem(1); OnAddRule((void*)1);	break;
				case 11: selectIf1->selectItem(1);	selectIf2->selectItem(0);	selectResult->selectItem(2); OnAddRule((void*)1);	break;
				case 12: selectIf1->selectItem(1);	selectIf2->selectItem(1);	selectResult->selectItem(0); OnAddRule((void*)1);	break;
				case 13: selectIf1->selectItem(1);	selectIf2->selectItem(1);	selectResult->selectItem(1); OnAddRule((void*)1);	break;
				case 14: selectIf1->selectItem(1);	selectIf2->selectItem(1);	selectResult->selectItem(2); OnAddRule((void*)1);	break;
				case 15: selectIf1->selectItem(1);	selectIf2->selectItem(2);	selectResult->selectItem(0); OnAddRule((void*)1);	break;
				case 16: selectIf1->selectItem(1);	selectIf2->selectItem(2);	selectResult->selectItem(1); OnAddRule((void*)1);	break;
				case 17: selectIf1->selectItem(1);	selectIf2->selectItem(2);	selectResult->selectItem(2); OnAddRule((void*)1);	break;

				case 18: selectIf1->selectItem(2);	selectIf2->selectItem(0);	selectResult->selectItem(0); OnAddRule((void*)1);	break;
				case 19: selectIf1->selectItem(2);	selectIf2->selectItem(0);	selectResult->selectItem(1); OnAddRule((void*)1);	break;
				case 20: selectIf1->selectItem(2);	selectIf2->selectItem(0);	selectResult->selectItem(2); OnAddRule((void*)1);	break;
				case 21: selectIf1->selectItem(2);	selectIf2->selectItem(1);	selectResult->selectItem(0); OnAddRule((void*)1);	break;
				case 22: selectIf1->selectItem(2);	selectIf2->selectItem(1);	selectResult->selectItem(1); OnAddRule((void*)1);	break;
				case 23: selectIf1->selectItem(2);	selectIf2->selectItem(1);	selectResult->selectItem(2); OnAddRule((void*)1);	break;
				case 24: selectIf1->selectItem(2);	selectIf2->selectItem(2);	selectResult->selectItem(0); OnAddRule((void*)1);	break;
				case 25: selectIf1->selectItem(2);	selectIf2->selectItem(2);	selectResult->selectItem(1); OnAddRule((void*)1);	break;
				case 26: selectIf1->selectItem(2);	selectIf2->selectItem(2);	selectResult->selectItem(2); OnAddRule((void*)1);	break;

				default: selectIf1->selectItem(0);	selectIf2->selectItem(0);	selectResult->selectItem(0); OnAddRule((void*)1);
			}
		}
	}

	delete binParametrs;
	//////////////////////////////////////////////////////////////////////////////////////////
	return 1;
}
void FuzzyWorker::FuzzyStartSimulation(void *obj)
{		
	Car->setPosition(10,Car->yPos);
	Car->setCaption("[()()>>");
	CarInfo.dMass = 10;							// 
	CarInfo.dSpeed = 1;							//  
	CarInfo.dDistance = 100;					//  
	CarInfo.dEnergy = CarInfo.dMass*(CarInfo.dSpeed*CarInfo.dSpeed)/2;  //  

	CarInfo.numEnergy = CarInfo.dEnergy;
	CarInfo.numSpeed = CarInfo.dSpeed;

	isStartedSimulation = true;

	//       
	CarInfo.distanceScale = CarInfo.numDistance/CarInfo.dDistance;
	CarInfo.energyScale = CarInfo.numEnergy/CarInfo.numDistance;  //      = CarInfo.numEnergy/4
}


void FuzzyWorker::OnRuleDelete(void* obj)
{
	GCP_Button* button = (GCP_Button*) obj;
	MainInterfaceForm->removeComponent(vectorRules.at(button->iRoundCff).label);
	vectorRules.erase(button->iRoundCff);
	MainInterfaceForm->removeComponent(button);

	for(int i=0; i<vectorRules.size(); i++)
	{
		Rule a =  vectorRules.at(i);
		a.label->setPosition(170,350+i*25);
		a.deleteb->setPosition(730,350+i*25);
		a.deleteb->iRoundCff = i;
	}
}

void FuzzyWorker::deleteRules()
{
	while(vectorRules.size()>0)
		OnRuleDelete((void*)vectorRules.at(0).deleteb);

}

void FuzzyWorker::defaultRules(void* obj)
{
	deleteRules();
	
	selectIf1->selectItem(0);	selectIf2->selectItem(2);	selectResult->selectItem(2); OnAddRule((void*)1);
	selectIf1->selectItem(1);	selectIf2->selectItem(2);	selectResult->selectItem(0); OnAddRule((void*)1);
	selectIf1->selectItem(2);	selectIf2->selectItem(2);	selectResult->selectItem(1); OnAddRule((void*)1);
	selectIf1->selectItem(1);	selectIf2->selectItem(1);	selectResult->selectItem(0); OnAddRule((void*)1);
	selectIf1->selectItem(2);	selectIf2->selectItem(0);	selectResult->selectItem(0); OnAddRule((void*)1);
	selectIf1->selectItem(1);	selectIf2->selectItem(0);	selectResult->selectItem(0); OnAddRule((void*)1);
	selectIf1->selectItem(2);	selectIf2->selectItem(0);	selectResult->selectItem(2); OnAddRule((void*)1);
	selectIf1->selectItem(2);	selectIf2->selectItem(0);	selectResult->selectItem(1); OnAddRule((void*)1);
	selectIf1->selectItem(2);	selectIf2->selectItem(0);	selectResult->selectItem(1); OnAddRule((void*)1);
	
}
void FuzzyWorker::OnAddRule(void* obj)
{

	if(selectResult->getSelectedItem() != "" && selectIf2->getSelectedItem() != "" && selectIf1->getSelectedItem() != "")
	{
		GCP_Label* label = new GCP_Label();
		string l = GCP_Math::RUSCP1251_TO_WCHAR("    '")+selectIf1->getSelectedItem()+
				   GCP_Math::RUSCP1251_TO_WCHAR("'       '")+selectIf2->getSelectedItem()+
				   GCP_Math::RUSCP1251_TO_WCHAR("'          '")+selectResult->getSelectedItem()+"'";
		label->text = l.c_str(); 
		label->setPosition(170,350+vectorRules.size()*25);
		label->setColor(c_white,c_black,c_white,c_black);

		GCP_Button* close = new GCP_Button();
		close->setCaption("-");
		close->setColor(c_black,c_white,c_aquadark,c_white);
		close->setWidthHeight(50,20);
		close->setPosition(730,350+vectorRules.size()*25);
		close->iRoundCff = vectorRules.size(); //!
		close->setOnMouseLeftClick(this,&FuzzyWorker::OnRuleDelete);

		Rule newrule;
		newrule.label = label;
		newrule.deleteb = close;

		switch(selectIf1->getSelectedItemIndex())
		{
			case 0: newrule.IF1 = FZDistance_trinagleLow; break;//
			case 1: newrule.IF1 = FZDistance_trinagleMedium; break;//
			case 2: newrule.IF1 = FZDistance_trinagleHigh; break;// 
		}

		switch(selectIf2->getSelectedItemIndex())
		{
			case 0: newrule.IF2 = FZEnergy_trinagleLow; break;//
			case 1: newrule.IF2 = FZEnergy_trinagleMedium; break;//
			case 2: newrule.IF2 = FZEnergy_trinagleHigh; break;// 
		}

		switch(selectResult->getSelectedItemIndex())
		{
			case 0: newrule.RE = FZStop_trinagleMedium; break;//
			case 1: newrule.RE = FZStop_trinagleHigh; break;// 
			case 2: newrule.RE = FZStop_trinagleLow; break;// 
		}	
		
		MainInterfaceForm->addComponent(close);
		MainInterfaceForm->addComponent(label);
		vectorRules.push_back(newrule);		
	}

}




simulationResult FuzzyWorker::drawSimulation()
{
	string result = "FAILURE";

	double speed;
	bool failed = false;
	
	if(isStartedSimulation)
	if(CarInfo.dEnergy > 0.1)
	{
		
		//10 -   
		//         
		CarInfo.dDistance = (CarInfo.numDistance-Car->xPos+10)/CarInfo.distanceScale;

		//         
		CarInfo.dEnergy += FuzzyOperation(CarInfo.dSpeed,CarInfo.dDistance);		
		if(CarInfo.dEnergy <= 0)
			CarInfo.dEnergy = 0;
		//     
		speed = sqrt(2*CarInfo.dEnergy/CarInfo.dMass);
		
		// 
		Car->setPosition(Car->xPos+speed*CarInfo.distanceScale,Car->yPos);

		// 
		if(Car->xPos+Car->width > bEndWall->xPos)
		{
			isStartedSimulation = false;
			Car->setPosition(bEndWall->xPos-Car->width,Car->yPos);
			Car->setCaption("  [xx|{");
			failed = true;
		}
	}
	else {
		isStartedSimulation =false;
		CarInfo.dEnergy = 0;
	}


	if(isStartedSimulation)
		result = "NOT DONE YET";
	else 
	{
		if(!failed) result = "SUCCESS";
	}

	

	simulationResult res;
	res.status = result;
	res.value = (int)(bEndWall->xPos-Car->width - Car->xPos);
	return res;
}
void FuzzyWorker::draw()
{
	SDL_SetRenderDrawColor(sdlRenderer,255,255,255,255);
	SDL_Rect recta = {0,0,SCREEN_WIDTH,SCREEN_HEIGHT};
	SDL_RenderFillRect(sdlRenderer,&recta);

	int param = 20;
	GCP_Draw::Draw_Line(sdlRenderer,0,Car->yPos+Car->height+3+param,SCREEN_WIDTH,Car->yPos+Car->height+3+param, c_black, 2);
	GCP_Draw::Draw_Line(sdlRenderer,0,Car->yPos+Car->height+50+param,SCREEN_WIDTH,Car->yPos+Car->height+50+param, c_black, 2);
	GCP_Draw::Draw_Line(sdlRenderer,0,Car->yPos+Car->height+100+param,SCREEN_WIDTH,Car->yPos+Car->height+100+param, c_black, 2);
	GCP_Draw::Draw_Line(sdlRenderer,0,Car->yPos+Car->height+150+param,SCREEN_WIDTH,Car->yPos+Car->height+150+param, c_black, 2);

	FZDistance_trinagleLow->draw(sdlRenderer);
	FZDistance_trinagleMedium->draw(sdlRenderer);
	FZDistance_trinagleHigh->draw(sdlRenderer);

	FZEnergy_trinagleLow->draw(sdlRenderer);
	FZEnergy_trinagleMedium->draw(sdlRenderer);
	FZEnergy_trinagleHigh->draw(sdlRenderer);

	FZStop_trinagleLow->draw(sdlRenderer);
	FZStop_trinagleMedium->draw(sdlRenderer);
	FZStop_trinagleHigh->draw(sdlRenderer);


	double aa = CarInfo.dEnergy/CarInfo.energyScale;
	GCP_Draw::Draw_FillRect(sdlRenderer,10+CarInfo.dEnergy/CarInfo.energyScale,Car->yPos+Car->height+50+param,10,20,c_orange);

	drawSimulation();

}

struct ruleExit
{
	double commonExitPercent, EnergyVal;
};
double FuzzyWorker::FuzzyOperation(double speed, double distance)
{
	ruleExit a;
	GCP_Vector<ruleExit> Exits;
	for(int i=0; i<vectorRules.size();i++)
	{
		Rule r= vectorRules.at(i);

		// ( )
		double distanceExit = r.IF1->getValue(Car->xPos);
		double energyExit =  r.IF2->getValue(CarInfo.dEnergy/CarInfo.energyScale);

		//   
		double commonExitPercent = distanceExit*energyExit/10000;

		//        
		double EnergyVal = r.RE->getValue(commonExitPercent*100,true);
		EnergyVal *= CarInfo.energyScale;

		
		a.commonExitPercent =commonExitPercent;

		//    
		a.EnergyVal  = EnergyVal/100;
		Exits.push_back(a);

	}
	double upSum=0,downSum=0;
	for(int i=0; i<Exits.size(); i++)
	{
		upSum += Exits.at(i).commonExitPercent*Exits.at(i).EnergyVal;
		downSum += Exits.at(i).commonExitPercent;
	}

	if(downSum ==0)
		return 0;
	return -upSum/downSum;
	//return -a.EnergyVal;
}

int FuzzyWorker::update()
{

	SDL_Event event;
	SDL_RenderClear(sdlRenderer);	
	while( SDL_PollEvent( &event ) )		//    SDL
	{ 				
		Interface->handleEvents(event);		// 	
		if(!MainInterfaceForm->isVisible)
			return -1;
	} 	
	draw();									//  
	Interface->draw();						// 	
	SDL_RenderPresent(sdlRenderer);
	//_isReculcOnUpdate = false;		
	return 0;
}
